# OpalMSRPMediaSession Class Reference

`#include <msrp.h>`

Inheritance diagram for OpalMSRPMediaSession:

[legend]
Collaboration diagram for OpalMSRPMediaSession:
[legend]

## Public Member Functions

| OpalMSRPMediaSession (const Init &init)
| ~OpalMSRPMediaSession ()
virtual PObject * | Clone () const
virtual const PCaselessString & | GetSessionType () const
virtual bool | Open (const PString &localInterface, const OpalTransportAddress &remoteAddress, bool isMediaAddress)
virtual bool | Close ()
virtual OpalTransportAddress | GetLocalAddress (bool isMediaAddress=true) const
virtual OpalTransportAddress | GetRemoteAddress (bool isMediaAddress=true) const
virtual bool | SetRemoteAddress (const OpalTransportAddress &remoteAddress, bool isMediaAddress=true)
virtual SDPMediaDescription * | CreateSDPMediaDescription ()
PURL | GetLocalURL () const
PURL | GetRemoteURL () const
void | SetRemoteURL (const PURL &url)
virtual bool | WritePacket (RTP_DataFrame &frame)
PBoolean | ReadData (BYTE *data, PINDEX length, PINDEX &read)
virtual OpalMediaStream * | CreateMediaStream (const OpalMediaFormat &mediaFormat, unsigned sessionID, PBoolean isSource)
OpalMSRPManager & | GetManager ()
bool | OpenMSRP (const PURL &remoteUrl)
void | CloseMSRP ()
void | SetConnection (PSafePtr< OpalMSRPManager::Connection > &conn)

## Static Public Member Functions

static const PCaselessString & | TCP_MSRP ()

## Data Fields

OpalMSRPManager & | m_manager
bool | m_isOriginating
std::string | m_localMSRPSessionId
PURL | m_localUrl
PURL | m_remoteUrl
PSafePtr< OpalMSRPManager::Connection > | m_connectionPtr
OpalTransportAddress | m_remoteAddress

## Detailed Description

Class for carrying MSRP session information

## Constructor & Destructor Documentation

OpalMSRPMediaSession::OpalMSRPMediaSession | ( | const Init & | init | ) |

OpalMSRPMediaSession::~OpalMSRPMediaSession | ( |  | ) |

## Member Function Documentation

virtual PObject* OpalMSRPMediaSession::Clone | ( |  | ) | const`[inline, virtual]`

virtual bool OpalMSRPMediaSession::Close | ( |  | ) | `[virtual]`

Reimplemented from OpalMediaSession.

void OpalMSRPMediaSession::CloseMSRP | ( |  | ) |

virtual OpalMediaStream* OpalMSRPMediaSession::CreateMediaStream | ( | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | PBoolean | isSource |
| ) |  |  | `[virtual]`

virtual SDPMediaDescription* OpalMSRPMediaSession::CreateSDPMediaDescription | ( |  | ) | `[virtual]`

Reimplemented from OpalMediaSession.

virtual OpalTransportAddress OpalMSRPMediaSession::GetLocalAddress | ( | bool | isMediaAddress = `true` | ) | const`[virtual]`

Reimplemented from OpalMediaSession.

PURL OpalMSRPMediaSession::GetLocalURL | ( |  | ) | const`[inline]`

OpalMSRPManager& OpalMSRPMediaSession::GetManager | ( |  | ) | `[inline]`

virtual OpalTransportAddress OpalMSRPMediaSession::GetRemoteAddress | ( | bool | isMediaAddress = `true` | ) | const`[virtual]`

Reimplemented from OpalMediaSession.

PURL OpalMSRPMediaSession::GetRemoteURL | ( |  | ) | const`[inline]`

virtual const PCaselessString& OpalMSRPMediaSession::GetSessionType | ( |  | ) | const`[inline, virtual]`

Implements OpalMediaSession.

virtual bool OpalMSRPMediaSession::Open | ( | const PString & | localInterface,
|  | const OpalTransportAddress & | remoteAddress,
|  | bool | isMediaAddress |
| ) |  |  | `[virtual]`

Reimplemented from OpalMediaSession.

bool OpalMSRPMediaSession::OpenMSRP | ( | const PURL & | remoteUrl | ) |

PBoolean OpalMSRPMediaSession::ReadData | ( | BYTE * | data,
|  | PINDEX | length,
|  | PINDEX & | read |
| ) |  |  |

void OpalMSRPMediaSession::SetConnection | ( | PSafePtr< OpalMSRPManager::Connection > & | conn | ) |

virtual bool OpalMSRPMediaSession::SetRemoteAddress | ( | const OpalTransportAddress & | remoteAddress,
|  | bool | isMediaAddress = `true` |
| ) |  |  | `[virtual]`

Reimplemented from OpalMediaSession.

void OpalMSRPMediaSession::SetRemoteURL | ( | const PURL & | url | ) | `[inline]`

static const PCaselessString& OpalMSRPMediaSession::TCP_MSRP | ( |  | ) | `[static]`

virtual bool OpalMSRPMediaSession::WritePacket | ( | RTP_DataFrame & | frame | ) | `[virtual]`

## Field Documentation

PSafePtr<OpalMSRPManager::Connection> OpalMSRPMediaSession::m_connectionPtr

bool OpalMSRPMediaSession::m_isOriginating

std::string OpalMSRPMediaSession::m_localMSRPSessionId

PURL OpalMSRPMediaSession::m_localUrl

OpalMSRPManager& OpalMSRPMediaSession::m_manager

OpalTransportAddress OpalMSRPMediaSession::m_remoteAddress

PURL OpalMSRPMediaSession::m_remoteUrl

The documentation for this class was generated from the following file:

- msrp.h